<?php

/**
 * registro_acta_inicio actions..
 *
 * @package    radicacionVirtualCuentas
 * @subpackage registro_acta_inicio
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class registro_acta_inicioActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_ACTA_INICIO_V',
        'RVC_CONTRATISTA_V',
        'RVC_TIPO_REGIMEN',
        'CIUDAD',
        'TS_UVT',
        'NO_SMDLV',
        'TIPO_DOCUMENTO',
        'RVC_CONTRATO_RPS_V',
        'RVC_CONTRATO_RPS_SUM_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RVC_CONTRATISTA_V,LEFT' =>
        array(
            'id_contratista' => 'RVC_ACTA_INICIO_V'
        ),
        'RVC_TIPO_REGIMEN,LEFT' =>
        array(
            'id_tipo_regimen' => 'RVC_CONTRATISTA_V'
        ),
        'CIUDAD,LEFT' =>
        array(
            'id_ciudad-id' => 'RVC_CONTRATISTA_V'
        ),
        'TS_UVT,LEFT' =>
        array(
            'year-vigencia' => 'RVC_ACTA_INICIO_V'
        ),
        'NO_SMDLV,LEFT' =>
        array(
            'year-vigencia' => 'RVC_ACTA_INICIO_V'
        ),
        'TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_doc' => 'RVC_CONTRATISTA_V'
        ),
         'RVC_CONTRATO_RPS_V,LEFT' =>
        array(
            'id_contrato' => 'RVC_ACTA_INICIO_V'
        ),
        'RVC_CONTRATO_RPS_SUM_V,LEFT' =>
        array(
            'id_contrato' => 'RVC_ACTA_INICIO_V'
        ),
        
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_ACTA_INICIO_V' =>
        array(
            'id_acta_inicio' => 'id_acta_inicio',
            'adjunto' => 'adjunto',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'num_doc_usu_log' => 'num_doc_usu_log',
            'razon_soc_usu_log' => 'razon_soc_usu_log',
            'id_contrato' => 'id_contrato',
            'id_contratista' => 'id_contratista',
            'num_contrato' => 'num_contrato',
            'id_anhos' => 'id_anhos',
            'fecha_contrato' => 'fecha_contrato',
            'objeto' => 'objeto',
            'obligaciones' => 'obligaciones',
            'estado' => 'estado',
            'rp_anm' => 'rp_anm',
            'rp_sgr' => 'rp_sgr',
            'rp_anm,||,rp_sgr' => 'rp',
            'fecha_rp' => 'fecha_rp',
            'fecha_rp_sgr' => 'fecha_rp_sgr',
            'fecha_poliza' => 'fecha_poliza',
            'valor_anm' => 'valor_anm',
            'cdp_anm' => 'cdp_anm',
            'fecha_cdp_anm' => 'fecha_cdp_anm',
            'valor_sgr' => 'valor_sgr',
            'cdp_sgr' => 'cdp_sgr',
            'fecha_cdp_sgr' => 'fecha_cdp_sgr',
            'dependencia' => 'dependencia',
            'meses_plazo' => 'meses_plazo',
            'dias_plazo' => 'dias_plazo',
//            'fecha_plazo' => 'fecha_plazo',
            'id_supervisor' => 'id_supervisor',
            'id_apoyo_supervisor' => 'id_apoyo_supervisor',
            'id_mae_ter_sup' => 'id_mae_ter_sup',
            'num_doc_sup' => 'num_doc_sup',
            'razon_soc_sup' => 'razon_soc_sup',
            'num_doc_sup,||, - ,||,razon_soc_sup' => 'completo_sup',
            'cargo_sup' => 'cargo_sup',
            'correo_sup' => 'correo_sup',
            'estado_sup' => 'estado_sup',
            'id_mae_ter_apo' => 'id_mae_ter_apo',
            'num_doc_apo' => 'num_doc_apo',
            'razon_soc_apo' => 'razon_soc_apo',
            'num_doc_apo,||, - ,||,razon_soc_apo' => 'completo_apo',
            'cargo_apo' => 'cargo_apo',
            'correo_apo' => 'correo_apo',
            'estado_apo' => 'estado_apo',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'fecha_inicio_actividades' => 'fecha_inicio_actividades',
            'valor_ejecutado' => 'valor_ejecutado',
            'firmado' => 'firmado',
            'fecha_firmado' => 'fecha_firmado',
            'usuario_firmado' => 'usuario_firmado',
            'autorizado' => 'autorizado',
            'fecha_autorizado' => 'fecha_autorizado',
            'usuario_autorizado' => 'usuario_autorizado',
            'observacion_aut' => 'observacion_aut',
            //'valor_contrato' => 'valor_contrato',
            'saldo_contrato' => 'saldo_contrato',
            'valor_ibc' => 'valor_ibc',
            'estado_general' => 'estado_general',
            'desc_estado_general' => 'desc_estado_general',
            'fecha_estado_general' => 'fecha_estado_general',
            'usuario_estado_general' => 'usuario_estado_general',
            'obs_estado_general' => 'obs_estado_general',
            'numero_pago' => 'numero_pago',
            'valor_mensualizado' => 'valor_mensualizado',
            'id_area' => 'id_area',
            'id_tipo_contrato' => 'id_tipo_contrato',
            'id_ciudad' => 'id_ciudad',
            'cargo' => 'cargo',            
            'descripcion_tipcon' => 'descripcion_tipcon',            
            'abreviatura_tipcon' => 'abreviatura_tipcon',
            'codigo_area' => 'codigo_area',
            'descripcion_area' => 'descripcion_area',
            'ciudad_acta' => 'ciudad_acta',
            'firmado_acta_ini'=>'firmado_acta_ini',
            'fecha_firmado_acta_ini'=>'fecha_firmado_acta_ini',
            'usuario_firmado_acta_ini'=>'usuario_firmado_acta_ini',
            'autorizado_acta_ini'=>'autorizado_acta_ini',
            'fecha_autorizado_acta_ini'=>'fecha_autorizado_acta_ini',
            'usuario_aut_acta_ini'=>'usuario_aut_acta_ini',
            'obs_aut_acta_ini'=>'obs_aut_acta_ini',
            'estado_general_acta_ini' => 'estado_general_acta_ini',
            'desc_estado_general_acta_ini' => 'desc_estado_general_acta_ini',
            'fecha_estado_general_acta_ini' => 'fecha_estado_general_acta_ini',
            //'usuario_estado_general_acta_ini' => 'usuario_estado_general_acta_ini',
            'obs_estado_general_acta_ini' => 'obs_estado_general_acta_ini',
            'formatos_pago' => 'formatos_pago',
            'adjunto_firmado' => 'adjunto_acta_firmado',
            'aplica_inicio_dif' => 'aplica_inicio_dif'
            
        ),
        'RVC_CONTRATISTA_V' =>
        array(
            'tipo_recurso' => 'tipo_recurso',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'razon_social' => 'razon_social',
            'correo' => 'correo',
            'estado' => 'estado_contratista',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'mas_empleados' => 'mas_empleados',
            'declarante_renta' => 'declarante_renta',
            'pensionado' => 'pensionado',
            'embargo' => 'embargo',
            'dependiente' => 'dependiente',
            'valor_embargo' => 'valor_embargo',
            'num_doc,||, - ,||,razon_social' => 'completo',
            'id_tipo_riesgo' => 'id_tipo_riesgo_cont',
            'id_declara_jura_nov' => 'id_declara_jura_nov',
            'adjunto_firmado' => 'adjunto_firmado',
            'aplica_balance_contrato' => 'aplica_balance_contrato',
            'fecha_afilia_arl'=>'fecha_afilia_arl'
        ),
        'RVC_TIPO_REGIMEN' =>
        array(
            'descripcion' => 'tipo_regimen',
            'aplica_iva' => 'aplica_iva'
        ),
        'CIUDAD' =>
        array(
            'nombre' => 'nombre_ciudad',
            'tarifa_ica' => 'tarifa_ica_ciudad',
            'base_deveg' => 'base_deveg',
            'base_deduc' => 'base_deduc',
            'tarifa_ica_extra' => 'tarifa_ica_extra'
        ),
        'TS_UVT' =>
        array(
            'vigencia' => 'vigencia',
            'valor_uvt' => 'valor_uvt'
        ),
        'NO_SMDLV' =>
        array(
            'valor_dia' => 'valor_dia_smdlv',
            'valor_mensual' => 'valor_mensual_smdlv'
        ),
        'TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'tipo_documento',
            'abreviacion' => 'abreviacion_td',
            'codigo_siif' => 'codigo_siif'
        ),
        'RVC_CONTRATO_RPS_V' =>
        array(
            'rp_detalles' => 'rp_detalles'
        ),
        'RVC_CONTRATO_RPS_SUM_V' =>
        array(
            'sum_rp_detalles' => 'valor_contrato'
        ),
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_ACTA_INICIO_V' => array(
            'id_acta_inicio,a' => array('!=' => array(-1)),
            'id_acta_inicio,b' => array('=' => array('id_acta_inicio')),
            'id_contrato' => array('=' => array('id_contrato')),
            'id_contratista' => array('=' => array('id_contratista')),
            'fecha_contrato' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_supervisor' => array('=' => array('id_supervisor')),
            'id_apoyo_supervisor' => array('=' => array('id_apoyo_supervisor')),
            'estado_general' => array('=' => array('estado_general')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'RVC_ACTA_INICIO_V' =>
        array(
            'num_contrato' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'id_anhos', 'num_contrato', 'fecha_contrato', 'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_acta_inicio'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_acta_inicio'); //llave primaria
    protected $field_names = array('adjunto', 'usuario_log', 'id_contrato', 'id_contratista', 'num_contrato', 'id_anhos', 'fecha_contrato', 'objeto', 'obligaciones', 'estado',
        'rp_anm', 'rp_sgr', 'fecha_rp', 'fecha_rp_sgr','fecha_poliza', 'valor_anm', 'cdp_anm', 'fecha_cdp_anm', 'valor_sgr', 'cdp_sgr', 'fecha_cdp_sgr',
        'dependencia', 'meses_plazo', 'dias_plazo',/*'fecha_plazo',*/'id_supervisor', 'id_apoyo_supervisor', 'fecha_ini', 'fecha_fin', 'fecha_inicio_actividades',
        'numero_pago', 'valor_mensualizado', 'id_area', 'id_tipo_contrato', 'id_ciudad', 'cargo','adjunto_poliza','aplica_inicio_dif'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_ACTA_INICIO'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_acta_inicio'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        $id_contrato = $request['id_contrato'];
        /*
         *  Validar la operación, ya sea por SQL
         */
        /**
         * Si aplica inicio Diferente al contrato la fecha de Inicio e Inicio de actividades no puede ser menor a la Fecha del Rp,
         * Fecha_afilia ARL y fecha de poliza
         */
        if($request['aplica_inicio_dif'] == "true") {
            $sql = <<<EOD
select 
nvl( to_char(case 
  when a.tipo_recurso= 0 then 
    case
      when a.fecha_rp < a.fecha_poliza then
        case when a.fecha_rp < b.fecha_afilia_arl then a.fecha_rp
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza < b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 1 then 
    case
      when a.fecha_rp_sgr < a.fecha_poliza then
        case when a.fecha_rp_sgr < b.fecha_afilia_arl then a.fecha_rp_sgr
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza < b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 2 then 
    case when a.fecha_rp < a.fecha_rp_sgr then
      case
        when a.fecha_rp < a.fecha_poliza then
          case when a.fecha_rp < b.fecha_afilia_arl then a.fecha_rp
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza < b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    else
      case
        when a.fecha_rp_sgr < a.fecha_poliza then
          case when a.fecha_rp_sgr < b.fecha_afilia_arl then a.fecha_rp_sgr
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza < b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    end
  else a.fecha_rp end,'yyyy-mm-dd') , a.fecha_poliza) as fecha_inicio_actividades,
      a.fecha_rp as fecha_rp_l,
      a.rp_anm as rp_anm_l,
      a.rp_sgr as rp_sgr_l,
      a.fecha_rp_sgr as fecha_rp_sgr_l,
      a.valor_anm as valor_anm_l,
      a.valor_sgr as valor_sgr_l    
from rvc_contrato a
join rvc_contratista b on a.id_contratista=b.id_contratista
where a.id_contrato = $id_contrato
EOD;
                $results = CN_TABLE::executeSQL($sql);
                if(count($results)>0){
                    $fecha_menor_valida = strtotime($results[0]['fecha_inicio_actividades']);
                    $fecha_inicio_colocada = strtotime($request['fecha_ini']);
                    if($fecha_menor_valida >= $fecha_inicio_colocada) {
                        $errors['mensaje'] = "La fecha de inicio no puede ser menor o igual a ".$results[0]['fecha_inicio_actividades'];
                        $errors['servicio'] = "registro_acta_inicio";
                    }
                }else{
                    // No ejecuta validacion
                } 
            
        }
        
        /* 20210805 Valida que exista una novedad de datos del contratista posterior a la creacion 
         * del contrato a la que pertenece el acta
         */
        $sql = <<<EOD
Select 
  tab0.id_contrato,
  tab0.num_contrato,
  tab0.fecha_contrato,
  tab1.fecha_novedad,
  case 
    when tab1.fecha_novedad is null then 0 
    else
      case when tab1.fecha_novedad > tab0.fecha_contrato then 1 else 0 end
    end as NOVEDAD_VALIDA
from
  rvc_contrato tab0
  left join (select id_contratista,max(fecha_log) as fecha_novedad
    from rvc_novedad_contratista 
    group by id_contratista)tab1 on tab1.id_contratista = tab0.id_contratista
where
  tab0.id_contrato = $id_contrato
EOD;
        $results = CN_TABLE::executeSQL($sql);
        if($results[0]['novedad_valida'] != 1 ) {
            $errors['mensaje'] = "Estimado contratista recuerde que debe realizar Actualización de Datos antes del registro de Acta de inicio.";
            $errors['servicio'] = "registro_acta_inicio";
        } 

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        $id_contrato = $request['id_contrato'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        /**
         * Si aplica inicio Diferente al contrato la fecha de Inicio e Inicio de actividades no puede ser menor a la Fecha del Rp,
         * Fecha_afilia ARL y fecha de poliza
         */
        if($request['aplica_inicio_dif'] == "true") {
            $sql = <<<EOD
select 
nvl( to_char(case 
  when a.tipo_recurso= 0 then 
    case
      when a.fecha_rp > a.fecha_poliza then
        case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 1 then 
    case
      when a.fecha_rp_sgr > a.fecha_poliza then
        case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 2 then 
    case when a.fecha_rp > a.fecha_rp_sgr then
      case
        when a.fecha_rp > a.fecha_poliza then
          case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    else
      case
        when a.fecha_rp_sgr > a.fecha_poliza then
          case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    end
  else a.fecha_rp end,'yyyy-mm-dd') , a.fecha_poliza) as fecha_inicio_actividades,
      a.fecha_rp as fecha_rp_l,
      a.rp_anm as rp_anm_l,
      a.rp_sgr as rp_sgr_l,
      a.fecha_rp_sgr as fecha_rp_sgr_l,
      a.valor_anm as valor_anm_l,
      a.valor_sgr as valor_sgr_l    
from rvc_contrato a
join rvc_contratista b on a.id_contratista=b.id_contratista
where a.id_contrato = $id_contrato
EOD;
                $results = CN_TABLE::executeSQL($sql);
                if(count($results)>0){
                    $fecha_menor_valida = strtotime($results[0]['fecha_inicio_actividades']);
                    $fecha_inicio_colocada = strtotime($request['fecha_ini']);
                    if($fecha_menor_valida >= $fecha_inicio_colocada) {
                        $errors['mensaje'] = "La fecha de inicio no puede ser menor o igual a ".$results[0]['fecha_inicio_actividades'];
                        $errors['servicio'] = "registro_acta_inicio";
                    }
                }else{
                    // No ejecuta validacion
                } 
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        $id_contrato = $request['id_contrato'];
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
            if($request['aplica_inicio_dif'] == "false") {
                //Establecemos fecha de inicio actividades segun lo requerido
                //Fecha mayor entre Fecha_rp(anm,sgr o ambas,fecha afilia arl o fecha poliza) con la siguiente consulta
                $sql = <<<EOD
select 
nvl( to_char(case 
  when a.tipo_recurso= 0 then 
    case
      when a.fecha_rp > a.fecha_poliza then
        case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 1 then 
    case
      when a.fecha_rp_sgr > a.fecha_poliza then
        case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 2 then 
    case when a.fecha_rp > a.fecha_rp_sgr then
      case
        when a.fecha_rp > a.fecha_poliza then
          case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    else
      case
        when a.fecha_rp_sgr > a.fecha_poliza then
          case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    end
  else a.fecha_rp end,'yyyy-mm-dd') , a.fecha_poliza) as fecha_inicio_actividades,
      a.fecha_rp as fecha_rp_l,
      a.rp_anm as rp_anm_l,
      a.rp_sgr as rp_sgr_l,
      a.fecha_rp_sgr as fecha_rp_sgr_l,
      a.valor_anm as valor_anm_l,
      a.valor_sgr as valor_sgr_l    
from rvc_contrato a
join rvc_contratista b on a.id_contratista=b.id_contratista
where a.id_contrato = $id_contrato
EOD;
                $results = CN_TABLE::executeSQL($sql);
                $tipo_recurso = 0;
                $tipo_recurso = $results[0]['tipo_recurso'];
                $fecha_rp_l=($results[0]['fecha_rp_l'] == null? CN_TABLE::fechaSistema():$results[0]['fecha_rp_l']);
                $rp_anm_l=$results[0]['rp_anm_l'];
                $rp_sgr_l=$results[0]['rp_sgr_l'];
                $fecha_rp_sgr_l=$results[0]['fecha_rp_sgr_l'];
                $valor_anm_l=$results[0]['valor_anm_l'];
                $valor_sgr_l=$results[0]['valor_sgr_l'];
                $request['fecha_rp']=$fecha_rp_l;
                $request['rp_anm']=$rp_anm_l;
                $request['rp_sgr']=$rp_sgr_l;
                $request['fecha_rp_sgr']=$fecha_rp_sgr_l;
                $request['valor_anm']=$valor_anm_l;
                $request['valor_sgr']=$valor_sgr_l;
                if(count($results)>0){
                    $request['fecha_inicio_actividades'] = $results[0]['fecha_inicio_actividades'];
                    $request['fecha_ini'] = $results[0]['fecha_inicio_actividades'];
                }else{
                    $request['fecha_inicio_actividades'] = $request['fecha_ini'];
                }
            } else {
                $request['fecha_inicio_actividades'] = $request['fecha_ini'];
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            if($request['aplica_inicio_dif'] == "false") {
                //Establecemos fecha de inicio actividades segun lo requerido
                //Fecha mayor entre Fecha_rp(anm,sgr o ambas,fecha afilia arl o fecha poliza) con la siguiente consulta
                $sql = <<<EOD
select 
nvl( to_char(case 
  when a.tipo_recurso= 0 then 
    case
      when a.fecha_rp > a.fecha_poliza then
        case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 1 then 
    case
      when a.fecha_rp_sgr > a.fecha_poliza then
        case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
            else b.fecha_afilia_arl end
      else 
        case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
            else b.fecha_afilia_arl end
      end
  when a.tipo_recurso= 2 then 
    case when a.fecha_rp > a.fecha_rp_sgr then
      case
        when a.fecha_rp > a.fecha_poliza then
          case when a.fecha_rp > b.fecha_afilia_arl then a.fecha_rp
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    else
      case
        when a.fecha_rp_sgr > a.fecha_poliza then
          case when a.fecha_rp_sgr > b.fecha_afilia_arl then a.fecha_rp_sgr
              else b.fecha_afilia_arl end
        else 
          case when a.fecha_poliza > b.fecha_afilia_arl then a.fecha_poliza 
              else b.fecha_afilia_arl end
        end
    end
  else a.fecha_rp end,'yyyy-mm-dd') , a.fecha_poliza) as fecha_inicio_actividades,
  a.fecha_rp as fecha_rp_l,
            a.rp_anm as rp_anm_l,
      a.rp_sgr as rp_sgr_l,
      a.fecha_rp_sgr as fecha_rp_sgr_l,
      a.valor_anm as valor_anm_l,
      a.valor_sgr as valor_sgr_l                        
from rvc_contrato a
join rvc_contratista b on a.id_contratista=b.id_contratista
where a.id_contrato =  $id_contrato
EOD;
                $results = CN_TABLE::executeSQL($sql);
                $tipo_recurso = 0;
                $tipo_recurso = $results[0]['tipo_recurso'];
                $fecha_rp_l=($results[0]['fecha_rp_l'] == null? CN_TABLE::fechaSistema():$results[0]['fecha_rp_l']);            
                $rp_anm_l=$results[0]['rp_anm_l'];
                $rp_sgr_l=$results[0]['rp_sgr_l'];
                $fecha_rp_sgr_l=$results[0]['fecha_rp_sgr_l'];
                $valor_anm_l=$results[0]['valor_anm_l'];
                $valor_sgr_l=$results[0]['valor_sgr_l'];
                $request['fecha_rp']=$fecha_rp_l;
                $request['rp_anm']=$rp_anm_l;
                $request['rp_sgr']=$rp_sgr_l;
                $request['fecha_rp_sgr']=$fecha_rp_sgr_l;
                $request['valor_anm']=$valor_anm_l;
                $request['valor_sgr']=$valor_sgr_l;
                if(count($results)>0){
                    $request['fecha_inicio_actividades'] = $results[0]['fecha_inicio_actividades'];
                    $request['fecha_ini'] = $results[0]['fecha_inicio_actividades'];
                }else{
                    $request['fecha_inicio_actividades'] = $request['fecha_ini'];
                }
            } else {
                $request['fecha_inicio_actividades'] = $request['fecha_ini'];
            }      
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Cuando el contratista modifique la fecha de Terminación del contrato en el registro 
             * de Acta de Inicio, esta se debe modificar en el registro del contrato inicial. 
             * Esto con el Fin de que el sistema permita realizar la cuenta de cobro y no indique 
             * que la fecha es superior. - 20181213
             */
            try {

                $fecha_fin = $list_data_post[0]['fecha_fin'];
                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_contratista = $list_data_post[0]['id_contratista'];
                $fecha_inicio_actividades = $list_data_post[0]['fecha_inicio_actividades'];
                $adjunto_poliza =  $list_data_post[0]['adjunto_poliza'];

                $sql = <<<EOD
update rvc_contrato 
set fecha_fin = TO_DATE('$fecha_fin','yyyy-mm-dd'),
fecha_ini = TO_DATE('$fecha_inicio_actividades','yyyy-mm-dd'),
adjunto_poliza = '$adjunto_poliza'
where 
id_contrato = $id_contrato
and id_contratista = $id_contratista                      
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Cuando el contratista modifique la fecha de Terminación del contrato en el registro 
             * de Acta de Inicio, esta se debe modificar en el registro del contrato inicial. 
             * Esto con el Fin de que el sistema permita realizar la cuenta de cobro y no indique 
             * que la fecha es superior. - 20181213
             */
            try {

                $fecha_fin = $request['fecha_fin'];
                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_contratista = $list_data_post[0]['id_contratista'];
                $fecha_inicio_actividades = $list_data_post[0]['fecha_inicio_actividades'];
                $adjunto_poliza =  $list_data_post[0]['adjunto_poliza'];

                $sql = <<<EOD
update rvc_contrato set fecha_fin = TO_DATE('$fecha_fin','yyyy-mm-dd'),
fecha_ini = TO_DATE('$fecha_inicio_actividades','yyyy-mm-dd'),
adjunto_poliza = '$adjunto_poliza'
where 
id_contrato = $id_contrato
and id_contratista = $id_contratista                      
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
